﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;

namespace _3台同時再生__server_
{
	public partial class MainForm : Form
	{
		private Microsoft.DirectX.AudioVideoPlayback.Video media;
		
		public MainForm()
		{
			InitializeComponent();
		}

		private void loop()
		{
			try {
				int port = int.Parse(portNumberTextBox.Text);

				System.Net.Sockets.TcpListener listener =
					new System.Net.Sockets.TcpListener(IPAddress.Any, port);

				listener.Start();

				System.Net.Sockets.TcpClient tcp = listener.AcceptTcpClient();
				System.Net.Sockets.NetworkStream ns = tcp.GetStream();
				System.IO.StreamReader reader = new System.IO.StreamReader(ns);
				System.IO.StreamWriter writer = new System.IO.StreamWriter(ns);

				// mediaが準備できるまでひたすら待つ
				while (media == null) ;

				writer.WriteLine("already.");
				writer.Flush();

				while (true) {
					string cmd = reader.ReadLine();

					switch (cmd) {
						case "play." :
							media.Play();
							break;
						case "pause." :
							media.Pause();
							break;
						case "stop." :
							media.Stop();
							break;
						default :
							break;
					}

					if (cmd == "quit.") break;
				}

				tcp.Close();
			}
			catch (Exception exp) {
				MessageBox.Show(exp.Message);
			}
		}

		private void MainForm_DragEnter(object sender, DragEventArgs e)
		{
			// マウスカーソルの変更
			e.Effect =
				e.Data.GetDataPresent(DataFormats.FileDrop) ?
				DragDropEffects.Move :
				DragDropEffects.None;
		}

		private void MainForm_DragDrop(object sender, DragEventArgs e)
		{
			// ドラッグされたファイルのファイル名
			string[] fileName =
				e.Data.GetData(DataFormats.FileDrop) as string[];

			if (media == null) {
				media = new Microsoft.DirectX.AudioVideoPlayback.Video(fileName[0]);
				media.Owner = this.panel1;
				media.Play();
				media.Pause();
			}
			else {
				media.Dispose();
				media = new Microsoft.DirectX.AudioVideoPlayback.Video(fileName[0]);
				media.Owner = this.panel1;
				media.Pause();
			}
		}

		private void MainForm_KeyDown(object sender, KeyEventArgs e)
		{
			if (media == null) return;

			if (e.Alt && e.KeyCode == Keys.Enter) {
				media.Fullscreen = !media.Fullscreen;
			}
		}

		private void startButton_Click(object sender, EventArgs e)
		{
			// TCP待ちうけ＆コマンド受信用スレッド
			System.Threading.Thread t =
				new System.Threading.Thread(
					new System.Threading.ThreadStart(loop));
			t.IsBackground = true;
			t.Start();

			this.startButton.Enabled = false;
		}

		private void panel1_PreviewKeyDown(object sender, PreviewKeyDownEventArgs e)
		{
			if (media == null) return;

			if (e.Alt && e.KeyCode == Keys.Enter) {
				media.Fullscreen = !media.Fullscreen;
			}
		}
	}
}
